﻿using System;
using System.Drawing;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.IO;

namespace Note654夏歆哲
{
    public partial class FrmLogin : Form
    {
        public FrmLogin()
        {
            InitializeComponent();
        }

        private void FrmLogin_Load(object sender, EventArgs e)
        {
            Image image = Properties.Resources._2;
            byte[] imageData = PublicVar.ImageToByteArray(image);
            PublicVar.avatars = imageData;
            Image image_bigsk = Properties.Resources.bigsk;
            byte[] imageData_bigsk = PublicVar.ImageToByteArray(image_bigsk);

            string connStr = "Data Source=(localdb)\\MSSQLLocalDB;Initial Catalog=master;Integrated Security=True";
            SqlConnection conn = new SqlConnection(connStr);
            conn.Open();

            string initSql = @"select case when exists (select * from sys.databases where name=N'NoteDB') then 1 else 0 end";
            SqlCommand initSqlCmd = new SqlCommand(initSql, conn);
            bool flag = true;
            if ((int)initSqlCmd.ExecuteScalar() == 1)
            {
                flag = false;
            }
            initSql = @"
if not exists (select * from sys.databases where name=N'NoteDB')
begin
	create database NoteDB collate Chinese_PRC_CI_AS;
end;
            ";
            initSqlCmd = new SqlCommand(initSql, conn);
            initSqlCmd.ExecuteNonQuery();
            conn.Close();

            if (flag)
            {
                connStr = "Data Source=(localdb)\\MSSQLLocalDB;Initial Catalog=NoteDB;Integrated Security=True";
                conn = new SqlConnection(connStr);
                conn.Open();

                string[] initSqls = {
@"create table UserLogin
(
	UserLoginID int constraint PK_ID_UserLogin primary key identity(1,1),
	UserAccount varchar(20) not null,
	UserPwd varchar(200) not null,
	UserPhoto VARBINARY(MAX) null,
);",
@"create table IncomeExpendType
(
	IncomeExpendTypeId int constraint PK_Id_IncomeExpendType primary key,
	TypeName varchar(50) not null,
	IncomeExpendTypeName varchar(20) not null,
	Remark text null,
);",
@"create table IncomeExpendDet
(
	IncomeExpendDetID int constraint PK_ID_IncomeExpendDet primary key,
	IncomeExpendTypeId int foreign key references IncomeExpendType(IncomeExpendTypeId),
	UserLoginID int constraint FK_UserLoginID_IncomeExpendDet_UserLogin foreign key(UserLoginID) references UserLogin(UserLoginID),
	AccountMoney money not null,
	IEDatetime datetime not null,
	Remark text
);"
                };
                foreach (string sql in initSqls)
                {
                    initSqlCmd = new SqlCommand(sql, conn);
                    initSqlCmd.ExecuteNonQuery();
                }

                string insertSql = $"insert into UserLogin values('admin', '21232f297a57a5a743894a0e4a801fc3', @avatars);";
                SqlCommand insertSqlCmd = new SqlCommand(insertSql, conn);
                insertSqlCmd.Parameters.AddWithValue("@avatars", imageData);
                insertSqlCmd.ExecuteNonQuery();
                insertSql = $"insert into UserLogin values('夏歆哲', '098f6bcd4621d373cade4e832627b4f6', @avatars);";
                insertSqlCmd = new SqlCommand(insertSql, conn);
                insertSqlCmd.Parameters.AddWithValue("@avatars", imageData_bigsk);
                insertSqlCmd.ExecuteNonQuery();

                conn.Close();
            }
        }

        private void login_Click(object sender, EventArgs e)
        {
            if (account.Text == "" || password.Text == "")
            {
                MessageBox.Show("账号或密码错误！");
                return;
            }

            string connStr = "Data Source=(localdb)\\MSSQLLocalDB;Initial Catalog=NoteDB;Integrated Security=True";
            SqlConnection conn = new SqlConnection(connStr);
            conn.Open();

            string selectSql = $"SELECT UserPwd, UserLoginID FROM UserLogin WHERE UserAccount = '{account.Text}'";
            SqlCommand selectSqlCmd = new SqlCommand(selectSql, conn);
            SqlDataReader reader = selectSqlCmd.ExecuteReader();

            bool flag = true;
            while (reader.Read())
            {
                flag = false;
                if (PublicVar.ComputeMd5Hash(password.Text) == reader[0].ToString())
                {
                    PublicVar.username = account.Text;
                    PublicVar.userID = (int)reader[1];
                    int hour = DateTime.Now.Hour;
                    string greeting = hour < 6 ? "凌晨好" : hour < 9 ? "清晨好" : hour < 12 ? "早上好" : hour < 14 ? "中午好" : hour < 17 ? "下午好" : hour < 19 ? "傍晚好" : hour < 22 ? " 晚上好" : "夜深了";
                    MessageBox.Show($"{greeting}！{account.Text}！");

                    MidManage mid = new MidManage();
                    mid.Show();
                    this.Visible = false;
                }
                else
                {
                    MessageBox.Show("账号或密码错误！");
                }
            }

            if (flag)
            {
                MessageBox.Show("账号或密码错误！");
            }

            conn.Close();
        }

        private void cancel_Click(object sender, EventArgs e)
        {
            Environment.Exit(0);
        }

        private void registration_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            FrmRegister reg = new FrmRegister();
            reg.Show();
        }

        private void account_TextChanged(object sender, EventArgs e)
        {
            if (account.Text != "")
            {
                string connStr = "Data Source=(localdb)\\MSSQLLocalDB;Initial Catalog=NoteDB;Integrated Security=True";
                SqlConnection conn = new SqlConnection(connStr);
                conn.Open();

                string selectSql = $"SELECT UserPhoto FROM UserLogin WHERE UserAccount = '{account.Text}'";
                SqlCommand selectSqlCmd = new SqlCommand(selectSql, conn);
                byte[] imageData = (byte[])selectSqlCmd.ExecuteScalar();

                if (imageData != null)
                {
                    using (MemoryStream ms = new MemoryStream(imageData))
                    {
                        Image image = Image.FromStream(ms);
                        avatars.Image = image;
                    }
                }
                conn.Close();
            }
        }
    }
}
