﻿using System;
using System.Data.SqlClient;
using System.Windows.Forms;
using System.Drawing;
using System.IO;

namespace Note654夏歆哲
{
    public partial class FrmRegister : Form
    {
        public FrmRegister()
        {
            InitializeComponent();
        }

        private void FrmRegister_Load(object sender, EventArgs e)
        {
            label4.Parent = pictureBox1;
            this.KeyDown += new KeyEventHandler(FrmRegister_KeyDown);
            this.KeyPreview = true;
        }
        private void FrmRegister_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                register.PerformClick();
            }
        }

        private void login_Click(object sender, EventArgs e)
        {
            bool flag = false;
            // Account
            if (account.Text == "")
            {
                flag = true;
                errorProvider1.SetError(account, "用户名不能为空！");
            }
            else
            {
                errorProvider1.SetError(account, "");
            }
            // Password
            if (password.Text == "")
            {
                flag = true;
                errorProvider1.SetError(password, "密码不能为空！");
            }
            else
            {
                errorProvider1.SetError(password, "");
            }
            // Confirm Password
            if (confirm_password.Text == "")
            {
                flag = true;
                errorProvider1.SetError(confirm_password, "确认密码不能为空！");
            }
            else
            {
                errorProvider1.SetError(confirm_password, "");
            }
            if (confirm_password.Text != password.Text)
            {
                flag = true;
                errorProvider1.SetError(confirm_password, "两次密码不相同！");
            }
            else
            {   
                if (!flag)
                {
                    errorProvider1.SetError(confirm_password, "");
                }
            }
            string connStr;
            SqlConnection conn;
            if (account.Text != "")
            {
                connStr = "Data Source=(localdb)\\MSSQLLocalDB;Initial Catalog=NoteDB;Integrated Security=True";
                conn = new SqlConnection(connStr);
                conn.Open();

                string selectSql = $"SELECT UserLoginID FROM UserLogin WHERE UserAccount = '{account.Text}'";
                SqlCommand selectSqlCmd = new SqlCommand(selectSql, conn);

                if (selectSqlCmd.ExecuteScalar() != null)
                {
                    errorProvider1.SetError(account, "用户已经存在！");
                    flag = true;
                }
                else
                {
                    errorProvider1.SetError(account, "");
                }
                conn.Close();
            }
            if (flag)
            {
                return;
            }

            connStr = "Data Source=(localdb)\\MSSQLLocalDB;Initial Catalog=NoteDB;Integrated Security=True";
            conn = new SqlConnection(connStr);
            conn.Open();

            string insertSql = $"insert into UserLogin values(@account, @password, @avatars);";
            SqlCommand insertSqlCmd = new SqlCommand(insertSql, conn);
            insertSqlCmd.Parameters.AddWithValue("@account", account.Text);
            insertSqlCmd.Parameters.AddWithValue("@password", PublicVar.ComputeMd5Hash(password.Text));
            insertSqlCmd.Parameters.AddWithValue("@avatars", PublicVar.avatars);
            insertSqlCmd.ExecuteNonQuery();
            MessageBox.Show("注册成功！");

            Image image = Properties.Resources._2;
            byte[] imageData = PublicVar.ImageToByteArray(image);
            PublicVar.avatars = imageData;

            this.Close();
        }

        private void cancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void modifyAvatars_CheckedChanged(object sender, EventArgs e)
        {
            if (modifyAvatars.Checked)
            {
                FrmChangeAvatars frmChangeAvatars = new FrmChangeAvatars();
                frmChangeAvatars.Show();
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (PublicVar.avatars != null)
            {
                using (MemoryStream ms = new MemoryStream(PublicVar.avatars))
                {
                    Image image = Image.FromStream(ms);
                    if (avatars.Image != image)
                    {
                        avatars.Image = image;
                    }
                }
            }
        }

        private void account_TextChanged(object sender, EventArgs e)
        {
            if (account.Text != "")
            {
                string connStr = "Data Source=(localdb)\\MSSQLLocalDB;Initial Catalog=NoteDB;Integrated Security=True";
                SqlConnection conn = new SqlConnection(connStr);
                conn.Open();

                string selectSql = $"SELECT UserLoginID FROM UserLogin WHERE UserAccount = '{account.Text}'";
                SqlCommand selectSqlCmd = new SqlCommand(selectSql, conn);

                if (selectSqlCmd.ExecuteScalar() != null)
                {
                    errorProvider1.SetError(account, "用户已经存在！");
                }
                else
                {
                    errorProvider1.SetError(account, "");
                }
                conn.Close();
            }
        }
    }
}
