﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.IO;

namespace Form1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void init_db()
        {
            string connStr = "Data Source=(localdb)\\MSSQLLocalDB;Initial Catalog=master;Integrated Security=True";
            SqlConnection conn = new SqlConnection(connStr);
            conn.Open();

            string initSql = @"select case when exists (select * from sys.databases where name=N'NoteDB') then 1 else 0 end";
            SqlCommand initSqlCmd = new SqlCommand(initSql, conn);
            bool flag = true;
            if ((int)initSqlCmd.ExecuteScalar() == 1)
            {
                flag = false;
            }
            initSql = @"
            if not exists (select * from sys.databases where name=N'NoteDB')
            begin
	            create database NoteDB collate Chinese_PRC_CI_AS;
            end;
            ";
            initSqlCmd = new SqlCommand(initSql, conn);
            initSqlCmd.ExecuteNonQuery();
            conn.Close();

            if (flag)
            {
                connStr = "Data Source=(localdb)\\MSSQLLocalDB;Initial Catalog=NoteDB;Integrated Security=True";
                conn = new SqlConnection(connStr);
                conn.Open();

                string[] initSqls = {
                @"create table UserLogin
                (
	                UserLoginID int constraint PK_ID_UserLogin primary key identity(1,1),
	                UserAccount varchar(20) not null,
	                UserPwd varchar(200) not null,
	                UserPhoto VARBINARY(MAX) null,
                );",
                @"create table IncomeExpendType
                (
	                IncomeExpendTypeId int constraint PK_Id_IncomeExpendType primary key,
	                TypeName varchar(50) not null,
	                IncomeExpendTypeName varchar(20) not null,
	                Remark text null,
                );",
                @"create table IncomeExpendDet
                (
	                IncomeExpendDetID int constraint PK_ID_IncomeExpendDet primary key,
	                IncomeExpendTypeId int foreign key references IncomeExpendType(IncomeExpendTypeId),
	                UserLoginID int constraint FK_UserLoginID_IncomeExpendDet_UserLogin foreign key(UserLoginID) references UserLogin(UserLoginID),
	                AccountMoney money not null,
	                IEDatetime datetime not null,
	                Remark text
                );"
                };
                foreach (string sql in initSqls)
                {
                    initSqlCmd = new SqlCommand(sql, conn);
                    initSqlCmd.ExecuteNonQuery();
                }

                Image image = Properties.Resources._default;
                byte[] imageData = PublicVar.ImageToByteArray(image);
                PublicVar.avatars = imageData;
                Image image_bigsk = Properties.Resources.bigsk;
                byte[] imageData_bigsk = PublicVar.ImageToByteArray(image_bigsk);

                string insertSql = $"insert into UserLogin values('admin', '21232f297a57a5a743894a0e4a801fc3', null);";
                SqlCommand insertSqlCmd = new SqlCommand(insertSql, conn);
                insertSqlCmd.Parameters.AddWithValue("@avatars", imageData);
                insertSqlCmd.ExecuteNonQuery();
                insertSql = $"insert into UserLogin values('夏歆哲', '098f6bcd4621d373cade4e832627b4f6', @avatars);";
                insertSqlCmd = new SqlCommand(insertSql, conn);
                insertSqlCmd.Parameters.AddWithValue("@avatars", imageData_bigsk);
                insertSqlCmd.ExecuteNonQuery();

                conn.Close();
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            init_db();

            string connStr = "Data Source=(localdb)\\MSSQLLocalDB;Initial Catalog=NoteDB;Integrated Security=True";
            using (SqlConnection con = new SqlConnection(connStr))
            {
                con.Open();
                string SqlString = "select * from UserLogin";
                using (SqlDataAdapter ada = new SqlDataAdapter(SqlString, con))
                {
                    DataSet ds = new DataSet();
                    ada.Fill(ds);
                    dataGridView1.DataSource = ds.Tables[0].DefaultView;

                    username.DataSource = ds.Tables[0].DefaultView;
                    username.DisplayMember = "UserAccount";
                    username.ValueMember = "UserLoginID";
                }
            }
        }

        private void username_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (username.Text != "")
            {
                uname.Text = username.Text;
                password.Text = "*****";
                string connStr = "Data Source=(localdb)\\MSSQLLocalDB;Initial Catalog=NoteDB;Integrated Security=True";
                SqlConnection conn = new SqlConnection(connStr);
                conn.Open();

                string selectSql = $"SELECT UserPhoto FROM UserLogin WHERE UserAccount = '{username.Text}'";
                SqlCommand selectSqlCmd = new SqlCommand(selectSql, conn);

                var rawData = selectSqlCmd.ExecuteScalar();
                if (rawData == DBNull.Value || rawData == null)
                {
                    Image image = Properties.Resources._default;
                    avatars.Image = image;
                    conn.Close();
                    return;
                }
                byte[] imageData = (byte[])selectSqlCmd.ExecuteScalar();

                if (imageData != null)
                {
                    using (MemoryStream ms = new MemoryStream(imageData))
                    {
                        Image image = Image.FromStream(ms);
                        avatars.Image = image;
                    }
                }
                else
                {
                    Image image = Properties.Resources._default;
                    avatars.Image = image;
                }
                conn.Close();
            }
        }

        private void confirm_Click(object sender, EventArgs e)
        {
            if (username.Text != "" && password.Text != "")
            {
                string connStr = "Data Source=(localdb)\\MSSQLLocalDB;Initial Catalog=NoteDB;Integrated Security=True";
                if (password.Text != "*****")
                {
                    using (SqlConnection con = new SqlConnection(connStr))
                    {
                        con.Open();
                        string SqlString = $"update UserLogin SET UserAccount=@account WHERE UserLoginID=@uid";
                        SqlCommand SqlStringCmd = new SqlCommand(SqlString, con);
                        SqlStringCmd.Parameters.AddWithValue("@account", uname.Text);
                        SqlStringCmd.Parameters.AddWithValue("@uid", username.SelectedValue);
                        SqlStringCmd.ExecuteNonQuery();
                    }
                }
                else
                {
                    using (SqlConnection con = new SqlConnection(connStr))
                    {
                        con.Open();
                        string SqlString = "update UserLogin SET UserAccount=@account, UserPwd=@pwd WHERE UserLoginID=@uid";
                        SqlCommand SqlStringCmd = new SqlCommand(SqlString, con);
                        SqlStringCmd.Parameters.AddWithValue("@account", uname.Text);
                        SqlStringCmd.Parameters.AddWithValue("@pwd", PublicVar.ComputeMd5Hash(password.Text));
                        SqlStringCmd.Parameters.AddWithValue("@uid", username.SelectedValue);
                        SqlStringCmd.ExecuteNonQuery();
                    }
                }
                MessageBox.Show("修改成功！");
            }
        }
    }
}
