﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Data.SqlClient;
using System.Windows.Forms;

namespace DataProcessing_654夏歆哲
{
    public partial class Form1 : Form
    {
        bool backupMode = true;
        public Form1()
        {
            InitializeComponent();
        }
        Database db = new Database();
        private void Form1_Load(object sender, EventArgs e)
        {
            databaseFilePath.Text = $"C:\\DB\\{DateTime.Now.ToString("yyyyMMddHHmmss")}.bak";
        }

        private void browse_Click(object sender, EventArgs e)
        {
            if (backupMode)
            {
                FolderBrowserDialog dialog = new FolderBrowserDialog();
                DialogResult dr = dialog.ShowDialog();
                if (dr == DialogResult.OK)
                {
                    databaseFilePath.Text = $"{dialog.SelectedPath}\\{DateTime.Now.ToString("yyyyMMddHHmmss")}.bak";
                }
            }
            else
            {
                OpenFileDialog dialog = new OpenFileDialog();
                DialogResult d = dialog.ShowDialog();
                if (d == DialogResult.OK)
                {
                    databaseFilePath.Text = $"{dialog.FileName}";
                }
            }
        }

        private void backup_Click(object sender, EventArgs e)
        {
            if (backupMode)
            {
                string sqlString = $"BACKUP DATABASE TestDB_654夏歆哲 TO DISK = '{databaseFilePath.Text}'";
                if (db.ExecuteSQL(sqlString) == 0)
                {
                    MessageBox.Show("备份失败！");
                }
                else
                {
                    MessageBox.Show("备份成功！");
                }
            }
            else
            {
                string sqlString = $"ALTER DATABASE TestDB_654夏歆哲 SET OFFLINE WITH ROLLBACK IMMEDIATE;RESTORE DATABASE TestDB_654夏歆哲 FROM DISK = '{databaseFilePath.Text}'";
                if (db.ExecuteSQL(sqlString) == 0)
                {
                    MessageBox.Show("还原失败！");
                }
                else
                {
                    MessageBox.Show("还原成功！");
                }
            }
        }

        private void backupDatabase_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            backupMode = true;
            confirm.Text = "备份";
            textLabel.Text = "备份的数据库文件：";
            databaseFilePath.Text = $"C:\\DB\\{DateTime.Now.ToString("yyyyMMddHHmmss")}.bak";
        }

        private void restoreDatabase_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            backupMode = false;
            confirm.Text = "还原";
            textLabel.Text = "还原的数据库文件：";
            databaseFilePath.Text = "";
        }
    }
}
