﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConExe1_654
{

    public interface IFlyable
    {
        void Fly(); 
    }
    class Program
    {
        static void Main(string[] args)
        {
            Bird[] birds = {
                new Magpie(),
                new Eagle(),
                new Penguin(),
                new Owl(),
            };
            foreach (Bird bird in birds)
            {
                bird.Eat();
            }

            IFlyable[] flys = new IFlyable[]
            {
                new Magpie(),
                new Eagle(),
                new Plane(),
                new Butterfly(),
                new Balloon()
            };
            foreach (IFlyable fly in flys)
            {
                fly.Fly();
            }
        }
    }

    abstract class Bird
    {
        public abstract void Eat();
    }

    class Magpie : Bird, IFlyable
    {
        public override void Eat()
        {
            Console.WriteLine("我是一只喜鹊，喜欢吃虫子。");
        }
        public void Fly()
        {
            Console.WriteLine("我是喜鹊，我会飞。");
        }
    }
    class Eagle : Bird, IFlyable
    {
        public override void Eat()
        {
            Console.WriteLine("我是一只老鹰，喜欢吃肉。");
        }
        public void Fly()
        {
            Console.WriteLine("我是老鹰，我会飞。");
        }
    }

    class Penguin : Bird
    {
        public override void Eat()
        {
            Console.WriteLine("我是一只企鹅，喜欢吃鱼。");
        }
    }
    class Owl : Bird
    {
        public override void Eat()
        {
            Console.WriteLine("我是一只猫头鹰，喜欢吃老鼠。");
        }
    }
    class Plane : IFlyable
    {
        public void Fly()
        {
            Console.WriteLine("我是飞机，我在三万英尺的高空飞翔。");
        }
    }
    class Butterfly : IFlyable
    {
        public void Fly()
        {
            Console.WriteLine("我是蝴蝶，会飞来飞去。");
        }
    }
    class Balloon : IFlyable
    {
        public void Fly()
        {
            Console.WriteLine("我是气球，我飘起来了。");
        }
    }
}
