﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Test_654
{
    interface IRunable
    {
        void Run();
    }
    class Person : IRunable
    {
        string name;
        int age;
        public string Name { get { return name; } set { name = Name; } }
        public int Age { get { return age; } set { age = Age; } }
        public Person(string name, int age)
        {
            this.name = name;
            this.age = age;
        }
        public virtual void Say()
        {
            Console.WriteLine("我是人");
        }
        public virtual void Run()
        {
            Console.WriteLine("人能跑");
        }
    }
    class Student : Person, IRunable
    {
        int id;
        public int Id { get { return id; } set { id = Id; } }
        public Student(int id, string name, int age) : base(name, age)
        {
            this.id = id;
        }
        public override void Say()
        {
            base.Say();
            Console.WriteLine("我是学生");
        }
        public override void Run()
        {
            base.Run();
            Console.WriteLine("学生能飞奔");
        }
    }
    class Teacher : Person, IRunable
    {
        public Teacher(string name, int age) : base(name, age)
        {
        }
        public override void Say()
        {
            base.Say();
            Console.WriteLine("我是老师");
        }
        public override void Run()
        {
            base.Run();
            Console.WriteLine("老师能跑步");
        }
    }
    class Car : IRunable
    {
        public void Run()
        {
            Console.WriteLine("汽车能跑");
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            Student stu = new Student(2311654, "Ian Xia", 20);
            Console.WriteLine($"学生学号{stu.Id}，学生姓名{stu.Name}，学生年龄{stu.Age}");
            stu.Run();
            Car ca = new Car();
            ca.Run();
        }
    }
}
