﻿using System;
using System.Windows.Forms;

namespace WinFormDateCalculation_654
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        private void confirm_Click(object sender, EventArgs e)
        {
            int year = calendar.SelectionStart.Year;
            int month = calendar.SelectionStart.Month;
            int date = calendar.SelectionStart.Day;

            listBox1.Items.Add(year + (DateTime.IsLeapYear(year) ? "是闰年" : "是平年") + $"，{month}月是{season(month)}，{month}月共有{monthDays(month)}天");
            listBox1.Items.Add($"{date}号是{year}的第{numberOfDays(year, month, date)}天");
        }
        private string season(int month)
        {
            switch (month)
            {
                case 3:case 4:case 5: return "春季";
                case 6:case 7:case 8: return "夏季";
                case 9:case 10:case 11: return "秋季";
                case 12:case 1:case 2: return "冬季";
                default: return "错误";
            }
        }
        private int monthDays(int month)
        {
            int[] daysOfMonth = new int[12] { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
            return daysOfMonth[month - 1];
        }
        private int numberOfDays(int year, int month, int date)
        {
            int sumup = 0;
            for (int i=1; i < month; i++)
            {
                sumup += monthDays(i);
            }
            sumup += date;
            if (DateTime.IsLeapYear(year)) {
                sumup++;
            }
            return sumup;
        }
        private void reset_Click(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
        }
        private void timer1_Tick(object sender, EventArgs e)
        {
            now.Text = DateTime.Now.ToString();
        }
        private void calendar_DateChanged(object sender, DateRangeEventArgs e)
        {
            year.Text = calendar.SelectionStart.ToString("yyyy");
            month.Text = calendar.SelectionStart.ToString("MM");
            date.Text = calendar.SelectionStart.ToString("dd");
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            year.Text = calendar.SelectionStart.ToString("yyyy");
            month.Text = calendar.SelectionStart.ToString("MM");
            date.Text = calendar.SelectionStart.ToString("dd");
        }
    }
}
